<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBalanceLog ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBalanceLog
 * @subpackage Arrays
 */
class ArrayOfBalanceLog extends AbstractStructArrayBase
{
    /**
     * The BalanceLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BalanceLog[]
     */
    public $BalanceLog;
    /**
     * Constructor method for ArrayOfBalanceLog
     * @uses ArrayOfBalanceLog::setBalanceLog()
     * @param \StructType\BalanceLog[] $balanceLog
     */
    public function __construct(array $balanceLog = array())
    {
        $this
            ->setBalanceLog($balanceLog);
    }
    /**
     * Get BalanceLog value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BalanceLog[]|null
     */
    public function getBalanceLog()
    {
        return isset($this->BalanceLog) ? $this->BalanceLog : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBalanceLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBalanceLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBalanceLogForArrayConstraintsFromSetBalanceLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBalanceLogBalanceLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfBalanceLogBalanceLogItem instanceof \StructType\BalanceLog) {
                $invalidValues[] = is_object($arrayOfBalanceLogBalanceLogItem) ? get_class($arrayOfBalanceLogBalanceLogItem) : sprintf('%s(%s)', gettype($arrayOfBalanceLogBalanceLogItem), var_export($arrayOfBalanceLogBalanceLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BalanceLog property can only contain items of type \StructType\BalanceLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BalanceLog value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BalanceLog[] $balanceLog
     * @return \ArrayType\ArrayOfBalanceLog
     */
    public function setBalanceLog(array $balanceLog = array())
    {
        // validation for constraint: array
        if ('' !== ($balanceLogArrayErrorMessage = self::validateBalanceLogForArrayConstraintsFromSetBalanceLog($balanceLog))) {
            throw new \InvalidArgumentException($balanceLogArrayErrorMessage, __LINE__);
        }
        if (is_null($balanceLog) || (is_array($balanceLog) && empty($balanceLog))) {
            unset($this->BalanceLog);
        } else {
            $this->BalanceLog = $balanceLog;
        }
        return $this;
    }
    /**
     * Add item to BalanceLog value
     * @throws \InvalidArgumentException
     * @param \StructType\BalanceLog $item
     * @return \ArrayType\ArrayOfBalanceLog
     */
    public function addToBalanceLog(\StructType\BalanceLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BalanceLog) {
            throw new \InvalidArgumentException(sprintf('The BalanceLog property can only contain items of type \StructType\BalanceLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BalanceLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BalanceLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BalanceLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BalanceLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BalanceLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BalanceLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BalanceLog
     */
    public function getAttributeName()
    {
        return 'BalanceLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBalanceLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
