<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCommandRestriction ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCommandRestriction
 * @subpackage Arrays
 */
class ArrayOfCommandRestriction extends AbstractStructArrayBase
{
    /**
     * The CommandRestriction
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CommandRestriction[]
     */
    public $CommandRestriction;
    /**
     * Constructor method for ArrayOfCommandRestriction
     * @uses ArrayOfCommandRestriction::setCommandRestriction()
     * @param \StructType\CommandRestriction[] $commandRestriction
     */
    public function __construct(array $commandRestriction = array())
    {
        $this
            ->setCommandRestriction($commandRestriction);
    }
    /**
     * Get CommandRestriction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CommandRestriction[]|null
     */
    public function getCommandRestriction()
    {
        return isset($this->CommandRestriction) ? $this->CommandRestriction : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCommandRestriction method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCommandRestriction method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCommandRestrictionForArrayConstraintsFromSetCommandRestriction(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCommandRestrictionCommandRestrictionItem) {
            // validation for constraint: itemType
            if (!$arrayOfCommandRestrictionCommandRestrictionItem instanceof \StructType\CommandRestriction) {
                $invalidValues[] = is_object($arrayOfCommandRestrictionCommandRestrictionItem) ? get_class($arrayOfCommandRestrictionCommandRestrictionItem) : sprintf('%s(%s)', gettype($arrayOfCommandRestrictionCommandRestrictionItem), var_export($arrayOfCommandRestrictionCommandRestrictionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CommandRestriction property can only contain items of type \StructType\CommandRestriction, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CommandRestriction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CommandRestriction[] $commandRestriction
     * @return \ArrayType\ArrayOfCommandRestriction
     */
    public function setCommandRestriction(array $commandRestriction = array())
    {
        // validation for constraint: array
        if ('' !== ($commandRestrictionArrayErrorMessage = self::validateCommandRestrictionForArrayConstraintsFromSetCommandRestriction($commandRestriction))) {
            throw new \InvalidArgumentException($commandRestrictionArrayErrorMessage, __LINE__);
        }
        if (is_null($commandRestriction) || (is_array($commandRestriction) && empty($commandRestriction))) {
            unset($this->CommandRestriction);
        } else {
            $this->CommandRestriction = $commandRestriction;
        }
        return $this;
    }
    /**
     * Add item to CommandRestriction value
     * @throws \InvalidArgumentException
     * @param \StructType\CommandRestriction $item
     * @return \ArrayType\ArrayOfCommandRestriction
     */
    public function addToCommandRestriction(\StructType\CommandRestriction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CommandRestriction) {
            throw new \InvalidArgumentException(sprintf('The CommandRestriction property can only contain items of type \StructType\CommandRestriction, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CommandRestriction[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CommandRestriction|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CommandRestriction|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CommandRestriction|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CommandRestriction|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CommandRestriction|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CommandRestriction
     */
    public function getAttributeName()
    {
        return 'CommandRestriction';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCommandRestriction
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
