<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeliveryChannel ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeliveryChannel
 * @subpackage Arrays
 */
class ArrayOfDeliveryChannel extends AbstractStructArrayBase
{
    /**
     * The DeliveryChannel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeliveryChannel[]
     */
    public $DeliveryChannel;
    /**
     * Constructor method for ArrayOfDeliveryChannel
     * @uses ArrayOfDeliveryChannel::setDeliveryChannel()
     * @param \StructType\DeliveryChannel[] $deliveryChannel
     */
    public function __construct(array $deliveryChannel = array())
    {
        $this
            ->setDeliveryChannel($deliveryChannel);
    }
    /**
     * Get DeliveryChannel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeliveryChannel[]|null
     */
    public function getDeliveryChannel()
    {
        return isset($this->DeliveryChannel) ? $this->DeliveryChannel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeliveryChannel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeliveryChannel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeliveryChannelForArrayConstraintsFromSetDeliveryChannel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeliveryChannelDeliveryChannelItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeliveryChannelDeliveryChannelItem instanceof \StructType\DeliveryChannel) {
                $invalidValues[] = is_object($arrayOfDeliveryChannelDeliveryChannelItem) ? get_class($arrayOfDeliveryChannelDeliveryChannelItem) : sprintf('%s(%s)', gettype($arrayOfDeliveryChannelDeliveryChannelItem), var_export($arrayOfDeliveryChannelDeliveryChannelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeliveryChannel property can only contain items of type \StructType\DeliveryChannel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeliveryChannel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryChannel[] $deliveryChannel
     * @return \ArrayType\ArrayOfDeliveryChannel
     */
    public function setDeliveryChannel(array $deliveryChannel = array())
    {
        // validation for constraint: array
        if ('' !== ($deliveryChannelArrayErrorMessage = self::validateDeliveryChannelForArrayConstraintsFromSetDeliveryChannel($deliveryChannel))) {
            throw new \InvalidArgumentException($deliveryChannelArrayErrorMessage, __LINE__);
        }
        if (is_null($deliveryChannel) || (is_array($deliveryChannel) && empty($deliveryChannel))) {
            unset($this->DeliveryChannel);
        } else {
            $this->DeliveryChannel = $deliveryChannel;
        }
        return $this;
    }
    /**
     * Add item to DeliveryChannel value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryChannel $item
     * @return \ArrayType\ArrayOfDeliveryChannel
     */
    public function addToDeliveryChannel(\StructType\DeliveryChannel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeliveryChannel) {
            throw new \InvalidArgumentException(sprintf('The DeliveryChannel property can only contain items of type \StructType\DeliveryChannel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeliveryChannel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeliveryChannel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeliveryChannel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeliveryChannel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeliveryChannel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeliveryChannel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeliveryChannel
     */
    public function getAttributeName()
    {
        return 'DeliveryChannel';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDeliveryChannel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
