<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRedemptionItemsLog ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRedemptionItemsLog
 * @subpackage Arrays
 */
class ArrayOfRedemptionItemsLog extends AbstractStructArrayBase
{
    /**
     * The RedemptionItemsLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RedemptionItemsLog[]
     */
    public $RedemptionItemsLog;
    /**
     * Constructor method for ArrayOfRedemptionItemsLog
     * @uses ArrayOfRedemptionItemsLog::setRedemptionItemsLog()
     * @param \StructType\RedemptionItemsLog[] $redemptionItemsLog
     */
    public function __construct(array $redemptionItemsLog = array())
    {
        $this
            ->setRedemptionItemsLog($redemptionItemsLog);
    }
    /**
     * Get RedemptionItemsLog value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RedemptionItemsLog[]|null
     */
    public function getRedemptionItemsLog()
    {
        return isset($this->RedemptionItemsLog) ? $this->RedemptionItemsLog : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRedemptionItemsLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRedemptionItemsLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRedemptionItemsLogForArrayConstraintsFromSetRedemptionItemsLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRedemptionItemsLogRedemptionItemsLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfRedemptionItemsLogRedemptionItemsLogItem instanceof \StructType\RedemptionItemsLog) {
                $invalidValues[] = is_object($arrayOfRedemptionItemsLogRedemptionItemsLogItem) ? get_class($arrayOfRedemptionItemsLogRedemptionItemsLogItem) : sprintf('%s(%s)', gettype($arrayOfRedemptionItemsLogRedemptionItemsLogItem), var_export($arrayOfRedemptionItemsLogRedemptionItemsLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RedemptionItemsLog property can only contain items of type \StructType\RedemptionItemsLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RedemptionItemsLog value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RedemptionItemsLog[] $redemptionItemsLog
     * @return \ArrayType\ArrayOfRedemptionItemsLog
     */
    public function setRedemptionItemsLog(array $redemptionItemsLog = array())
    {
        // validation for constraint: array
        if ('' !== ($redemptionItemsLogArrayErrorMessage = self::validateRedemptionItemsLogForArrayConstraintsFromSetRedemptionItemsLog($redemptionItemsLog))) {
            throw new \InvalidArgumentException($redemptionItemsLogArrayErrorMessage, __LINE__);
        }
        if (is_null($redemptionItemsLog) || (is_array($redemptionItemsLog) && empty($redemptionItemsLog))) {
            unset($this->RedemptionItemsLog);
        } else {
            $this->RedemptionItemsLog = $redemptionItemsLog;
        }
        return $this;
    }
    /**
     * Add item to RedemptionItemsLog value
     * @throws \InvalidArgumentException
     * @param \StructType\RedemptionItemsLog $item
     * @return \ArrayType\ArrayOfRedemptionItemsLog
     */
    public function addToRedemptionItemsLog(\StructType\RedemptionItemsLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RedemptionItemsLog) {
            throw new \InvalidArgumentException(sprintf('The RedemptionItemsLog property can only contain items of type \StructType\RedemptionItemsLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RedemptionItemsLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RedemptionItemsLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RedemptionItemsLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RedemptionItemsLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RedemptionItemsLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RedemptionItemsLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RedemptionItemsLog
     */
    public function getAttributeName()
    {
        return 'RedemptionItemsLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRedemptionItemsLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
