<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRedemptionLog ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRedemptionLog
 * @subpackage Arrays
 */
class ArrayOfRedemptionLog extends AbstractStructArrayBase
{
    /**
     * The RedemptionLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RedemptionLog[]
     */
    public $RedemptionLog;
    /**
     * Constructor method for ArrayOfRedemptionLog
     * @uses ArrayOfRedemptionLog::setRedemptionLog()
     * @param \StructType\RedemptionLog[] $redemptionLog
     */
    public function __construct(array $redemptionLog = array())
    {
        $this
            ->setRedemptionLog($redemptionLog);
    }
    /**
     * Get RedemptionLog value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RedemptionLog[]|null
     */
    public function getRedemptionLog()
    {
        return isset($this->RedemptionLog) ? $this->RedemptionLog : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRedemptionLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRedemptionLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRedemptionLogForArrayConstraintsFromSetRedemptionLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRedemptionLogRedemptionLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfRedemptionLogRedemptionLogItem instanceof \StructType\RedemptionLog) {
                $invalidValues[] = is_object($arrayOfRedemptionLogRedemptionLogItem) ? get_class($arrayOfRedemptionLogRedemptionLogItem) : sprintf('%s(%s)', gettype($arrayOfRedemptionLogRedemptionLogItem), var_export($arrayOfRedemptionLogRedemptionLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RedemptionLog property can only contain items of type \StructType\RedemptionLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RedemptionLog value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RedemptionLog[] $redemptionLog
     * @return \ArrayType\ArrayOfRedemptionLog
     */
    public function setRedemptionLog(array $redemptionLog = array())
    {
        // validation for constraint: array
        if ('' !== ($redemptionLogArrayErrorMessage = self::validateRedemptionLogForArrayConstraintsFromSetRedemptionLog($redemptionLog))) {
            throw new \InvalidArgumentException($redemptionLogArrayErrorMessage, __LINE__);
        }
        if (is_null($redemptionLog) || (is_array($redemptionLog) && empty($redemptionLog))) {
            unset($this->RedemptionLog);
        } else {
            $this->RedemptionLog = $redemptionLog;
        }
        return $this;
    }
    /**
     * Add item to RedemptionLog value
     * @throws \InvalidArgumentException
     * @param \StructType\RedemptionLog $item
     * @return \ArrayType\ArrayOfRedemptionLog
     */
    public function addToRedemptionLog(\StructType\RedemptionLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RedemptionLog) {
            throw new \InvalidArgumentException(sprintf('The RedemptionLog property can only contain items of type \StructType\RedemptionLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RedemptionLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RedemptionLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RedemptionLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RedemptionLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RedemptionLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RedemptionLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RedemptionLog
     */
    public function getAttributeName()
    {
        return 'RedemptionLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRedemptionLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
