<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWalletTransferDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWalletTransferDetails
 * @subpackage Arrays
 */
class ArrayOfWalletTransferDetails extends AbstractStructArrayBase
{
    /**
     * The WalletTransferDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WalletTransferDetails[]
     */
    public $WalletTransferDetails;
    /**
     * Constructor method for ArrayOfWalletTransferDetails
     * @uses ArrayOfWalletTransferDetails::setWalletTransferDetails()
     * @param \StructType\WalletTransferDetails[] $walletTransferDetails
     */
    public function __construct(array $walletTransferDetails = array())
    {
        $this
            ->setWalletTransferDetails($walletTransferDetails);
    }
    /**
     * Get WalletTransferDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WalletTransferDetails[]|null
     */
    public function getWalletTransferDetails()
    {
        return isset($this->WalletTransferDetails) ? $this->WalletTransferDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWalletTransferDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWalletTransferDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWalletTransferDetailsForArrayConstraintsFromSetWalletTransferDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWalletTransferDetailsWalletTransferDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfWalletTransferDetailsWalletTransferDetailsItem instanceof \StructType\WalletTransferDetails) {
                $invalidValues[] = is_object($arrayOfWalletTransferDetailsWalletTransferDetailsItem) ? get_class($arrayOfWalletTransferDetailsWalletTransferDetailsItem) : sprintf('%s(%s)', gettype($arrayOfWalletTransferDetailsWalletTransferDetailsItem), var_export($arrayOfWalletTransferDetailsWalletTransferDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WalletTransferDetails property can only contain items of type \StructType\WalletTransferDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WalletTransferDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WalletTransferDetails[] $walletTransferDetails
     * @return \ArrayType\ArrayOfWalletTransferDetails
     */
    public function setWalletTransferDetails(array $walletTransferDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($walletTransferDetailsArrayErrorMessage = self::validateWalletTransferDetailsForArrayConstraintsFromSetWalletTransferDetails($walletTransferDetails))) {
            throw new \InvalidArgumentException($walletTransferDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($walletTransferDetails) || (is_array($walletTransferDetails) && empty($walletTransferDetails))) {
            unset($this->WalletTransferDetails);
        } else {
            $this->WalletTransferDetails = $walletTransferDetails;
        }
        return $this;
    }
    /**
     * Add item to WalletTransferDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\WalletTransferDetails $item
     * @return \ArrayType\ArrayOfWalletTransferDetails
     */
    public function addToWalletTransferDetails(\StructType\WalletTransferDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WalletTransferDetails) {
            throw new \InvalidArgumentException(sprintf('The WalletTransferDetails property can only contain items of type \StructType\WalletTransferDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WalletTransferDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WalletTransferDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WalletTransferDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WalletTransferDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WalletTransferDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WalletTransferDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WalletTransferDetails
     */
    public function getAttributeName()
    {
        return 'WalletTransferDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfWalletTransferDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
