<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'QueryAvailableItems' => '\\StructType\\QueryAvailableItems',
            'QueryAvailableItemsResponse' => '\\StructType\\QueryAvailableItemsResponse',
            'QueryPoints' => '\\StructType\\QueryPoints',
            'QueryPointsResponse' => '\\StructType\\QueryPointsResponse',
            'GetMyWalletsWithPoints' => '\\StructType\\GetMyWalletsWithPoints',
            'GetMyWalletsWithPointsResponse' => '\\StructType\\GetMyWalletsWithPointsResponse',
            'GetMyWalletsWithStockPoints' => '\\StructType\\GetMyWalletsWithStockPoints',
            'GetMyWalletsWithStockPointsResponse' => '\\StructType\\GetMyWalletsWithStockPointsResponse',
            'IsCustomerRegistered' => '\\StructType\\IsCustomerRegistered',
            'IsCustomerRegisteredResponse' => '\\StructType\\IsCustomerRegisteredResponse',
            'RedemptionHistory' => '\\StructType\\RedemptionHistory',
            'RedemptionHistoryResponse' => '\\StructType\\RedemptionHistoryResponse',
            'QueryStockPoints' => '\\StructType\\QueryStockPoints',
            'QueryStockPointsResponse' => '\\StructType\\QueryStockPointsResponse',
            'GivePoints' => '\\StructType\\GivePoints',
            'GivePointsResponse' => '\\StructType\\GivePointsResponse',
            'TakePoints' => '\\StructType\\TakePoints',
            'TakePointsResponse' => '\\StructType\\TakePointsResponse',
            'GetCommandPrice' => '\\StructType\\GetCommandPrice',
            'GetCommandPriceResponse' => '\\StructType\\GetCommandPriceResponse',
            'BuyPoints' => '\\StructType\\BuyPoints',
            'BuyPointsResponse' => '\\StructType\\BuyPointsResponse',
            'RedeemItems' => '\\StructType\\RedeemItems',
            'RedeemItemsResponse' => '\\StructType\\RedeemItemsResponse',
            'RedeemItemsBeta' => '\\StructType\\RedeemItemsBeta',
            'RedeemItemsBetaResponse' => '\\StructType\\RedeemItemsBetaResponse',
            'CancelRedeem' => '\\StructType\\CancelRedeem',
            'CancelRedeemResponse' => '\\StructType\\CancelRedeemResponse',
            'DeliverItems' => '\\StructType\\DeliverItems',
            'DeliverItemsResponse' => '\\StructType\\DeliverItemsResponse',
            'GetCommandRestrictions' => '\\StructType\\GetCommandRestrictions',
            'GetCommandRestrictionsResponse' => '\\StructType\\GetCommandRestrictionsResponse',
            'GetLineMembersWalletsCount' => '\\StructType\\GetLineMembersWalletsCount',
            'GetLineMembersWalletsCountResponse' => '\\StructType\\GetLineMembersWalletsCountResponse',
            'GetLineMembersPoints' => '\\StructType\\GetLineMembersPoints',
            'GetLineMembersPointsResponse' => '\\StructType\\GetLineMembersPointsResponse',
            'GetAvailableWalletsForCommand' => '\\StructType\\GetAvailableWalletsForCommand',
            'GetAvailableWalletsForCommandResponse' => '\\StructType\\GetAvailableWalletsForCommandResponse',
            'GetTransferDetails' => '\\StructType\\GetTransferDetails',
            'GetTransferDetailsResponse' => '\\StructType\\GetTransferDetailsResponse',
            'UnRegister' => '\\StructType\\UnRegister',
            'UnRegisterResponse' => '\\StructType\\UnRegisterResponse',
            'Register' => '\\StructType\\Register',
            'RegisterResponse' => '\\StructType\\RegisterResponse',
            'RedeemableItemDetails' => '\\StructType\\RedeemableItemDetails',
            'RedeemableItemDetailsResponse' => '\\StructType\\RedeemableItemDetailsResponse',
            'EnableCustomer' => '\\StructType\\EnableCustomer',
            'EnableCustomerResponse' => '\\StructType\\EnableCustomerResponse',
            'DisableCustomer' => '\\StructType\\DisableCustomer',
            'DisableCustomerResponse' => '\\StructType\\DisableCustomerResponse',
            'GetOrdersSummary' => '\\StructType\\GetOrdersSummary',
            'GetOrdersSummaryResponse' => '\\StructType\\GetOrdersSummaryResponse',
            'GetCataloguesSummary' => '\\StructType\\GetCataloguesSummary',
            'GetCataloguesSummaryResponse' => '\\StructType\\GetCataloguesSummaryResponse',
            'AddPoints' => '\\StructType\\AddPoints',
            'AddPointsResponse' => '\\StructType\\AddPointsResponse',
            'RemovePoints' => '\\StructType\\RemovePoints',
            'RemovePointsResponse' => '\\StructType\\RemovePointsResponse',
            'GetAccountMembersWithRegistrationInfo' => '\\StructType\\GetAccountMembersWithRegistrationInfo',
            'GetAccountMembersWithRegistrationInfoResponse' => '\\StructType\\GetAccountMembersWithRegistrationInfoResponse',
            'BalanceHistory' => '\\StructType\\BalanceHistory',
            'BalanceHistoryResponse' => '\\StructType\\BalanceHistoryResponse',
            'GetLostPoints' => '\\StructType\\GetLostPoints',
            'GetLostPointsResponse' => '\\StructType\\GetLostPointsResponse',
            'GetNextRedemptionDate' => '\\StructType\\GetNextRedemptionDate',
            'GetNextRedemptionDateResponse' => '\\StructType\\GetNextRedemptionDateResponse',
            'PasswordRequest' => '\\StructType\\PasswordRequest',
            'PasswordRequestResponse' => '\\StructType\\PasswordRequestResponse',
            'SendEmailLink' => '\\StructType\\SendEmailLink',
            'SendEmailLinkResponse' => '\\StructType\\SendEmailLinkResponse',
            'QueryDefaultAvailableItems' => '\\StructType\\QueryDefaultAvailableItems',
            'QueryDefaultAvailableItemsResponse' => '\\StructType\\QueryDefaultAvailableItemsResponse',
            'GetDeliveryChannels' => '\\StructType\\GetDeliveryChannels',
            'GetDeliveryChannelsResponse' => '\\StructType\\GetDeliveryChannelsResponse',
            'GetAvailableQuantity' => '\\StructType\\GetAvailableQuantity',
            'GetAvailableQuantityResponse' => '\\StructType\\GetAvailableQuantityResponse',
            'ChangePassword' => '\\StructType\\ChangePassword',
            'ChangePasswordResponse' => '\\StructType\\ChangePasswordResponse',
            'GetDeliveryChannelTypes' => '\\StructType\\GetDeliveryChannelTypes',
            'GetDeliveryChannelTypesResponse' => '\\StructType\\GetDeliveryChannelTypesResponse',
            'GetAreas' => '\\StructType\\GetAreas',
            'GetAreasResponse' => '\\StructType\\GetAreasResponse',
            'GetArea' => '\\StructType\\GetArea',
            'GetAreaResponse' => '\\StructType\\GetAreaResponse',
            'Customer' => '\\StructType\\Customer',
            'RedeemableItemsResponse' => '\\StructType\\RedeemableItemsResponse',
            'ApiResponse' => '\\StructType\\ApiResponse',
            'WalletsResponse' => '\\StructType\\WalletsResponse',
            'QueryRedemptionHistoryResponse' => '\\StructType\\QueryRedemptionHistoryResponse',
            'CommandPriceResponse' => '\\StructType\\CommandPriceResponse',
            'RedemptionResponse' => '\\StructType\\RedemptionResponse',
            'DeliverItemsRequest' => '\\StructType\\DeliverItemsRequest',
            'CommandRestrictionsResponse' => '\\StructType\\CommandRestrictionsResponse',
            'WalletsTransferDetailsResponse' => '\\StructType\\WalletsTransferDetailsResponse',
            'OrdersSummaryResponse' => '\\StructType\\OrdersSummaryResponse',
            'CataloguesSummaryResponse' => '\\StructType\\CataloguesSummaryResponse',
            'NextRedemptionDateResponse' => '\\StructType\\NextRedemptionDateResponse',
            'DeliveryChannelsResponse' => '\\StructType\\DeliveryChannelsResponse',
            'DeliveryChannelTypesResponse' => '\\StructType\\DeliveryChannelTypesResponse',
            'AreasResponse' => '\\StructType\\AreasResponse',
            'Error' => '\\StructType\\Error',
            'ArrayOfRedeemableItem' => '\\ArrayType\\ArrayOfRedeemableItem',
            'RedeemableItem' => '\\StructType\\RedeemableItem',
            'RedeemableItemCatalogue' => '\\StructType\\RedeemableItemCatalogue',
            'ArrayOfRedeemableItemCategory' => '\\ArrayType\\ArrayOfRedeemableItemCategory',
            'RedeemableItemCategory' => '\\StructType\\RedeemableItemCategory',
            'ArrayOfRedeemableItemPrice' => '\\ArrayType\\ArrayOfRedeemableItemPrice',
            'RedeemableItemPrice' => '\\StructType\\RedeemableItemPrice',
            'WalletType' => '\\StructType\\WalletType',
            'ArrayOfWallet' => '\\ArrayType\\ArrayOfWallet',
            'Wallet' => '\\StructType\\Wallet',
            'ArrayOfStock' => '\\ArrayType\\ArrayOfStock',
            'Stock' => '\\StructType\\Stock',
            'ArrayOfRedemptionLog' => '\\ArrayType\\ArrayOfRedemptionLog',
            'RedemptionLog' => '\\StructType\\RedemptionLog',
            'ArrayOfRedemptionItemsLog' => '\\ArrayType\\ArrayOfRedemptionItemsLog',
            'RedemptionItemsLog' => '\\StructType\\RedemptionItemsLog',
            'Command' => '\\StructType\\Command',
            'DeliveryChannel' => '\\StructType\\DeliveryChannel',
            'ArrayOfRedemptionItemPointsLog' => '\\ArrayType\\ArrayOfRedemptionItemPointsLog',
            'RedemptionItemPointsLog' => '\\StructType\\RedemptionItemPointsLog',
            'CommandReason' => '\\StructType\\CommandReason',
            'ArrayOfPurchaseOrderItem' => '\\ArrayType\\ArrayOfPurchaseOrderItem',
            'PurchaseOrderItem' => '\\StructType\\PurchaseOrderItem',
            'ArrayOfPurchaseOrderItemInfo' => '\\ArrayType\\ArrayOfPurchaseOrderItemInfo',
            'PurchaseOrderItemInfo' => '\\StructType\\PurchaseOrderItemInfo',
            'CancelRedeemRequest' => '\\StructType\\CancelRedeemRequest',
            'ArrayOfRedeemItemCancel' => '\\ArrayType\\ArrayOfRedeemItemCancel',
            'RedeemItemCancel' => '\\StructType\\RedeemItemCancel',
            'ArrayOfCommandRestriction' => '\\ArrayType\\ArrayOfCommandRestriction',
            'CommandRestriction' => '\\StructType\\CommandRestriction',
            'ArrayOfWalletTransferDetails' => '\\ArrayType\\ArrayOfWalletTransferDetails',
            'WalletTransferDetails' => '\\StructType\\WalletTransferDetails',
            'ArrayOfBalanceLog' => '\\ArrayType\\ArrayOfBalanceLog',
            'BalanceLog' => '\\StructType\\BalanceLog',
            'ArrayOfDeliveryChannel' => '\\ArrayType\\ArrayOfDeliveryChannel',
            'ArrayOfDeliveryChannelType' => '\\ArrayType\\ArrayOfDeliveryChannelType',
            'DeliveryChannelType' => '\\StructType\\DeliveryChannelType',
            'ArrayOfArea' => '\\ArrayType\\ArrayOfArea',
            'Area' => '\\StructType\\Area',
            'ArrayOfunsignedByte' => '\\ArrayType\\ArrayOfunsignedByte',
            'ArrayOfKeyValueOfCustomerintbMZLxG6p' => '\\ArrayType\\ArrayOfKeyValueOfCustomerintbMZLxG6p',
            'KeyValueOfCustomerintbMZLxG6p' => '\\StructType\\KeyValueOfCustomerintbMZLxG6p',
            'ArrayOfKeyValueOfCustomerArrayOfWalletFJlD39bd' => '\\ArrayType\\ArrayOfKeyValueOfCustomerArrayOfWalletFJlD39bd',
            'KeyValueOfCustomerArrayOfWalletFJlD39bd' => '\\StructType\\KeyValueOfCustomerArrayOfWalletFJlD39bd',
            'ArrayOflong' => '\\ArrayType\\ArrayOflong',
            'ArrayOfKeyValueOfshortAreaNNoFT2Ls' => '\\ArrayType\\ArrayOfKeyValueOfshortAreaNNoFT2Ls',
            'KeyValueOfshortAreaNNoFT2Ls' => '\\StructType\\KeyValueOfshortAreaNNoFT2Ls',
            'LineMembersWalletsResponse' => '\\StructType\\LineMembersWalletsResponse',
            'LineMembersPointsResponse' => '\\StructType\\LineMembersPointsResponse',
            'CustWithRegInfoResponse' => '\\StructType\\CustWithRegInfoResponse',
            'ArrayOfCustWithRegInfo' => '\\ArrayType\\ArrayOfCustWithRegInfo',
            'CustWithRegInfo' => '\\StructType\\CustWithRegInfo',
            'ItemsQuantityResponse' => '\\StructType\\ItemsQuantityResponse',
            'AreaResponse' => '\\StructType\\AreaResponse',
            'ArrayOfItemQuantity' => '\\ArrayType\\ArrayOfItemQuantity',
            'ItemQuantity' => '\\StructType\\ItemQuantity',
        );
    }
}
