<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BalanceHistoryResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:BalanceHistoryResponse
 * @subpackage Structs
 */
class BalanceHistoryResponse extends ApiResponse
{
    /**
     * The BalanceHistoryResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BalanceHistoryResponse
     */
    public $BalanceHistoryResult;
    /**
     * The BalanceLogs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfBalanceLog
     */
    public $BalanceLogs;
    /**
     * Constructor method for BalanceHistoryResponse
     * @uses BalanceHistoryResponse::setBalanceHistoryResult()
     * @uses BalanceHistoryResponse::setBalanceLogs()
     * @param \StructType\BalanceHistoryResponse $balanceHistoryResult
     * @param \ArrayType\ArrayOfBalanceLog $balanceLogs
     */
    public function __construct(\StructType\BalanceHistoryResponse $balanceHistoryResult = null, \ArrayType\ArrayOfBalanceLog $balanceLogs = null)
    {
        $this
            ->setBalanceHistoryResult($balanceHistoryResult)
            ->setBalanceLogs($balanceLogs);
    }
    /**
     * Get BalanceHistoryResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BalanceHistoryResponse|null
     */
    public function getBalanceHistoryResult()
    {
        return isset($this->BalanceHistoryResult) ? $this->BalanceHistoryResult : null;
    }
    /**
     * Set BalanceHistoryResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BalanceHistoryResponse $balanceHistoryResult
     * @return \StructType\BalanceHistoryResponse
     */
    public function setBalanceHistoryResult(\StructType\BalanceHistoryResponse $balanceHistoryResult = null)
    {
        if (is_null($balanceHistoryResult) || (is_array($balanceHistoryResult) && empty($balanceHistoryResult))) {
            unset($this->BalanceHistoryResult);
        } else {
            $this->BalanceHistoryResult = $balanceHistoryResult;
        }
        return $this;
    }
    /**
     * Get BalanceLogs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfBalanceLog|null
     */
    public function getBalanceLogs()
    {
        return isset($this->BalanceLogs) ? $this->BalanceLogs : null;
    }
    /**
     * Set BalanceLogs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfBalanceLog $balanceLogs
     * @return \StructType\BalanceHistoryResponse
     */
    public function setBalanceLogs(\ArrayType\ArrayOfBalanceLog $balanceLogs = null)
    {
        if (is_null($balanceLogs) || (is_array($balanceLogs) && empty($balanceLogs))) {
            unset($this->BalanceLogs);
        } else {
            $this->BalanceLogs = $balanceLogs;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BalanceHistoryResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
