<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeliverItemsRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DeliverItemsRequest
 * @subpackage Structs
 */
class DeliverItemsRequest extends AbstractStructBase
{
    /**
     * The RedemptionItemLogId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RedemptionItemLogId;
    /**
     * The RedemptionLogId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RedemptionLogId;
    /**
     * Constructor method for DeliverItemsRequest
     * @uses DeliverItemsRequest::setRedemptionItemLogId()
     * @uses DeliverItemsRequest::setRedemptionLogId()
     * @param int $redemptionItemLogId
     * @param int $redemptionLogId
     */
    public function __construct($redemptionItemLogId = null, $redemptionLogId = null)
    {
        $this
            ->setRedemptionItemLogId($redemptionItemLogId)
            ->setRedemptionLogId($redemptionLogId);
    }
    /**
     * Get RedemptionItemLogId value
     * @return int|null
     */
    public function getRedemptionItemLogId()
    {
        return $this->RedemptionItemLogId;
    }
    /**
     * Set RedemptionItemLogId value
     * @param int $redemptionItemLogId
     * @return \StructType\DeliverItemsRequest
     */
    public function setRedemptionItemLogId($redemptionItemLogId = null)
    {
        // validation for constraint: int
        if (!is_null($redemptionItemLogId) && !(is_int($redemptionItemLogId) || ctype_digit($redemptionItemLogId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($redemptionItemLogId, true), gettype($redemptionItemLogId)), __LINE__);
        }
        $this->RedemptionItemLogId = $redemptionItemLogId;
        return $this;
    }
    /**
     * Get RedemptionLogId value
     * @return int|null
     */
    public function getRedemptionLogId()
    {
        return $this->RedemptionLogId;
    }
    /**
     * Set RedemptionLogId value
     * @param int $redemptionLogId
     * @return \StructType\DeliverItemsRequest
     */
    public function setRedemptionLogId($redemptionLogId = null)
    {
        // validation for constraint: int
        if (!is_null($redemptionLogId) && !(is_int($redemptionLogId) || ctype_digit($redemptionLogId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($redemptionLogId, true), gettype($redemptionLogId)), __LINE__);
        }
        $this->RedemptionLogId = $redemptionLogId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeliverItemsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
